Loading...
Searching...
No Matches
juce::ModalComponentManager Class Reference

## Detailed Description

Manages the system's stack of modal components.

Normally you'll just use the Component methods to invoke modal states in components, and won't have to deal with this class directly, but this is the singleton object that's used internally to manage the stack.

See also
  Component::enterModalState, Component::exitModalState, Component::isCurrentlyModal, Component::getCurrentlyModalComponent, Component::isCurrentlyBlockedByAnotherModalComponent

The documentation for this class was generated from the following file:

- juce_gui_basics/components/juce_ModalComponentManager.h

Inheritance diagram for juce::ModalComponentManager:

## Classes

class | Callback
| Receives callbacks when a modal component is dismissed. More...
class | Key

## Public Member Functions

int | getNumModalComponents () const
| Returns the number of components currently being shown modally.
Component * | getModalComponent (int index) const
| Returns one of the components being shown modally.
bool | isModal (const Component *component) const
| Returns true if the specified component is in a modal state.
bool | isFrontModalComponent (const Component *component) const
| Returns true if the specified component is currently the topmost modal component.
void | attachCallback (Component *component, Callback *callback)
| Adds a new callback that will be called when the specified modal component is dismissed.
void | bringModalComponentsToFront (bool topOneShouldGrabFocus=true)
| Brings any modal components to the front.
bool | cancelAllModalComponents ()
| Calls exitModalState (0) on any components that are currently modal.
int | runEventLoopForCurrentComponent ()
| Runs the event loop until the currently topmost modal component is dismissed, and returns the exit code for that component.
void | startModal (Key, Component *, bool autoDelete)
void | endModal (Key, Component *, int returnValue)

## Protected Member Functions

| ModalComponentManager ()
| Creates a ModalComponentManager.
| ~ModalComponentManager () override
| Destructor.
void | handleAsyncUpdate () override
| Called back to do whatever your class needs to do.

## Constructors and Destructors

## ModalComponentManager()

juce::ModalComponentManager::ModalComponentManager | ( |  | ) |

protected

Creates a ModalComponentManager.

You shouldn't ever call the constructor - it's a singleton, so use ModalComponentManager::getInstance()

Referenced by handleAsyncUpdate().

## ~ModalComponentManager()

juce::ModalComponentManager::~ModalComponentManager | ( |  | ) |

override protected

Destructor.

## Member Functions

## getNumModalComponents()

int juce::ModalComponentManager::getNumModalComponents | ( |  | ) | const

Returns the number of components currently being shown modally.

See also
  getModalComponent

References getNumModalComponents().

Referenced by getNumModalComponents().

## getModalComponent()

Component * juce::ModalComponentManager::getModalComponent | ( | int | index | ) | const

Returns one of the components being shown modally.

An index of 0 is the most recently-shown, topmost component.

References getModalComponent().

Referenced by getModalComponent().

## isModal()

bool juce::ModalComponentManager::isModal | ( | const Component * | component | ) | const

Returns true if the specified component is in a modal state.

References isModal().

Referenced by isModal().

## isFrontModalComponent()

bool juce::ModalComponentManager::isFrontModalComponent | ( | const Component * | component | ) | const

Returns true if the specified component is currently the topmost modal component.

References isFrontModalComponent().

Referenced by isFrontModalComponent().

## attachCallback()

void juce::ModalComponentManager::attachCallback | ( | Component * | component,
|  | Callback * | callback )

Adds a new callback that will be called when the specified modal component is dismissed.

If the component is modal, then when it is dismissed, either by being hidden, or by calling Component::exitModalState(), then the Callback::modalStateFinished() method will be called.

Each component can have any number of callbacks associated with it, and this one is added to that list.

The object that is passed in will be deleted by the manager when it's no longer needed. If the given component is not currently modal, the callback object is deleted immediately and no action is taken.

References attachCallback().

Referenced by attachCallback().

## bringModalComponentsToFront()

void juce::ModalComponentManager::bringModalComponentsToFront | ( | bool | topOneShouldGrabFocus = true | ) |

Brings any modal components to the front.

References bringModalComponentsToFront().

Referenced by bringModalComponentsToFront().

## cancelAllModalComponents()

bool juce::ModalComponentManager::cancelAllModalComponents | ( |  | ) |

Calls exitModalState (0) on any components that are currently modal.

Returns
  true if any components were modal; false if nothing needed cancelling

References cancelAllModalComponents().

Referenced by cancelAllModalComponents().

## runEventLoopForCurrentComponent()

int juce::ModalComponentManager::runEventLoopForCurrentComponent | ( |  | ) |

Runs the event loop until the currently topmost modal component is dismissed, and returns the exit code for that component.

## startModal()

void juce::ModalComponentManager::startModal | ( | Key | ,
|  | Component * | ,
|  | bool | autoDelete )

## endModal()

void juce::ModalComponentManager::endModal | ( | Key | ,
|  | Component * | ,
|  | int | returnValue )

## handleAsyncUpdate()

void juce::ModalComponentManager::handleAsyncUpdate | ( |  | ) |

override protected virtual

Called back to do whatever your class needs to do.

This method is called by the message thread at the next convenient time after the triggerAsyncUpdate() method has been called.

Implements juce::AsyncUpdater.

References ModalComponentManager().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited